import { apiConfig } from '@/config/api.config';
import { Alert, useDataGrid } from '@/components';
import { useCallApi } from '@/hooks';
import { getAuth } from '@/auth';
import React, { useCallback, useEffect, useRef, useState } from 'react';
import { toast } from 'sonner';
import {
  Dialog,
  DialogBody,
  DialogContent,
  DialogDescription,
  DialogHeader,
  DialogTitle
} from '@/components/ui/dialog';
import { Input } from '@/components/ui/input';
import { Button } from '@/components/ui/button';
import { NumericFormat } from 'react-number-format';
import { Popover, PopoverContent, PopoverTrigger } from '@/components/ui/popover';
import {
  Command,
  CommandEmpty,
  CommandGroup,
  CommandInput,
  CommandItem,
  CommandList
} from '@/components/ui/command';
import { set } from 'date-fns';
import {
  Select,
  SelectContent,
  SelectItem,
  SelectTrigger,
  SelectValue
} from '@/components/ui/select';
import { useManageConversionContext } from '../hooks/useManageConversionContext';
import { doSaveLogActivity } from '@/actions/GlobalActions';
interface CurrencyProps {
  ID: string;
  name: string;
}

const API_URL = apiConfig.service_wallet;

const AddDialog = () => {
  const parentRef = useRef<any | null>(null);
  const { showAddDialog, handleAddDialog, selectedConversion } = useManageConversionContext();
  const { reload } = useDataGrid();
  const { PostData, GetData } = useCallApi();
  const parsedUser = getAuth()?.user;
  const [currencies, setCurrencies] = useState<CurrencyProps[]>([]);
  const [open, setOpen] = useState(false);
  const [alert, setAlert] = useState({
    show: false,
    message: ''
  });
  const initialState = {
    status: '',
    id_currency_origin: '',
    id_currency_destination: '',
    buy: 0,
    sell: 0,
    created_by: '',
    created_at: ''
  };
  const [formField, setFormField] = useState(initialState);
  const created_time = new Date();
  const formattedTime = created_time.toISOString().slice(0, 19).replace('T', ' ');

  const resetForm = () => {
    setFormField(initialState);
    setAlert({ show: false, message: '' });
  };

  const doCreateConversion = useCallback(
    async (e: React.FormEvent<HTMLFormElement>) => {
      e.preventDefault();

      const response = await PostData(`${API_URL}/dashboard/conversion`, formField);

      if (response?.status) {
        resetForm();
        handleAddDialog(false);
        toast.success('Success Create Conversion');
        const createActivity = {
          module: 'Manage Conversion',
          description: `Create Conversion => ${formField.id_currency_origin} => ${formField.id_currency_destination}`,
          action: 'C'
        };

        doSaveLogActivity(createActivity);
        reload();
      } else {
        toast.error('Error Create Conversion');
        setAlert({ show: true, message: 'Failed to create Conversion. Please try again.' });
      }
    },
    [formField]
  );

  const doFetchCurrency = async (sorting: any) => {
    try {
      sorting = sorting.length == 0 ? [{ id: 'name', desc: false }] : sorting;
      const response = await GetData(`${API_URL}/dashboard/currency/`, {
        limit: 1000,
        page: 1,
        with_deleted: false,
        order_field: sorting[0].id,
        order_direction: sorting[0].desc == false ? 'ASC' : 'DESC'
      });

      setCurrencies(response?.data.list);
    } catch (error) {
      console.error('Error fetching currency', error);
    }
  };

  const handleSubmit = (e: React.FormEvent<HTMLFormElement>) => {
    e.preventDefault();

    if (
      formField.id_currency_origin === '' ||
      formField.id_currency_destination === '' ||
      formField.buy === 0 ||
      formField.sell === 0 ||
      formField.status === ''
    ) {
      setAlert({ show: true, message: 'Please fill in all required fields.' });
      return;
    }

    doCreateConversion(e);
    // console.log(formField);
    setAlert({ show: false, message: '' });
  };

  useEffect(() => {
    if (showAddDialog) {
      setFormField({
        ...formField,
        created_by: parsedUser.username,
        created_at: formattedTime
      });
    }
  }, [formattedTime]);

  useEffect(() => {
    doFetchCurrency([{ id: 'name', desc: false }]);
  }, []);

  useEffect(() => {
    if (showAddDialog === false) {
      resetForm();
    }
  }, [showAddDialog]);

  return (
    <Dialog open={showAddDialog} onOpenChange={(open) => handleAddDialog(open)}>
      <DialogContent className="container-fixed max-w-[768px] flex flex-col p-5 overflow-hidden">
        <DialogHeader>
          <DialogTitle>Conversion - Create</DialogTitle>
          <DialogDescription></DialogDescription>
        </DialogHeader>
        <DialogBody ref={parentRef}>
          <div className="flex flex-col">
            {alert.show && (
              <Alert variant="danger">
                <h3>{alert.message}</h3>
              </Alert>
            )}

            <form onSubmit={handleSubmit}>
              <div className="card-body grid gap-5">
                <div className="w-full">
                  <label className="form-label">
                    Currency Origin <span className="text-red-500">*</span>
                  </label>
                  <Select
                    value={formField.id_currency_origin}
                    onValueChange={(id_currency_origin) =>
                      setFormField((prev) => ({ ...prev, id_currency_origin }))
                    }
                  >
                    <SelectTrigger>
                      <SelectValue placeholder="Select Currency" />
                    </SelectTrigger>
                    <SelectContent>
                      {currencies.map((currency, idx) => (
                        <SelectItem value={currency.ID} key={currency.ID}>
                          {currency.name}
                        </SelectItem>
                      ))}
                    </SelectContent>
                  </Select>
                </div>
                <div className="w-full">
                  <label className="form-label">
                    Currency Destination <span className="text-red-500">*</span>
                  </label>
                  <Select
                    value={formField.id_currency_destination}
                    onValueChange={(id_currency_destination) =>
                      setFormField((prev) => ({ ...prev, id_currency_destination }))
                    }
                  >
                    <SelectTrigger>
                      <SelectValue placeholder="Select Currency" />
                    </SelectTrigger>
                    <SelectContent>
                      {currencies.map((currency, idx) => (
                        <SelectItem value={currency.ID} key={currency.ID}>
                          {currency.name}
                        </SelectItem>
                      ))}
                    </SelectContent>
                  </Select>
                </div>
                <div className="w-full">
                  <label className="form-label">
                    Buy<span className="text-red-500">*</span>
                  </label>
                  <NumericFormat
                    className="input"
                    value={formField.buy}
                    thousandSeparator="."
                    decimalSeparator=","
                    allowNegative={false}
                    onValueChange={(values) => {
                      setFormField((prev) => ({
                        ...prev,
                        buy: values.floatValue || 0
                      }));
                    }}
                    placeholder="Enter Buy"
                  />
                </div>
                <div className="w-full">
                  <label className="form-label">
                    Sell
                    <span className="text-red-500">*</span>
                  </label>
                  <NumericFormat
                    className="input"
                    value={formField.sell}
                    thousandSeparator="."
                    decimalSeparator=","
                    allowNegative={false}
                    onValueChange={(values) => {
                      setFormField((prev) => ({
                        ...prev,
                        sell: values.floatValue || 0
                      }));
                    }}
                    placeholder="Enter Sell"
                  />
                </div>
                <div className="w-full">
                  <label className="form-label">
                    Status
                    <span className="text-red-500">*</span>
                  </label>

                  <div className="grow">
                    <Select
                      value={formField.status}
                      onValueChange={(value) =>
                        setFormField((prev) => ({ ...prev, status: value }))
                      }
                    >
                      <SelectTrigger>
                        <SelectValue placeholder="Select" />
                      </SelectTrigger>
                      <SelectContent>
                        <SelectItem value="Y">Active</SelectItem>
                        <SelectItem value="N">Inactive</SelectItem>
                      </SelectContent>
                    </Select>
                  </div>
                </div>
                <div className="flex justify-end gap-5">
                  <Button type="button" variant="outline" onClick={resetForm}>
                    Reset
                  </Button>
                  <Button variant="default">Save Changes</Button>
                </div>
              </div>
            </form>
          </div>
        </DialogBody>
      </DialogContent>
    </Dialog>
  );
};

export default AddDialog;
